function [value,qmatrix] = UQI(img1, img2,N)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% INPUT
% img1: Image 1
% img2: Image 2
% N: Block Dimension
% OUTPUT
% value: Q value
% qmatrix: Q indexes for each block
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

img1 = double(img1);
img2 = double(img2);

window = ones(N,N);
window = window./sum(window(:));

mu1   = filter2(window, img1, 'valid');
mu2   = filter2(window, img2, 'valid');
mu1_sq = mu1.*mu1;
mu2_sq = mu2.*mu2;
mu1_mu2 = mu1.*mu2;
sigma1_sq = filter2(window, img1.*img1, 'valid') - mu1_sq;
sigma2_sq = filter2(window, img2.*img2, 'valid') - mu2_sq;
sigma12 = filter2(window, img1.*img2, 'valid') - mu1_mu2;

qmatrix = ((2*mu1_mu2 ).*(2*sigma12))./((mu1_sq + mu2_sq).*(sigma1_sq + sigma2_sq));

value = mean2(qmatrix);

return